﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
<Serializable()>
Public Class Form1
   Private Sub AddWMSService()
      Dim oOverlay As LayerOverlay
      Dim oWMSLayer As New WmsRasterLayer(New Uri("http://imsref.cr.usgs.gov:80/wmsconnector/com.esri.wms.Esrimap/USGS_EDC_LandCover_NLCD"))
      Dim oMap As WinformsMap = WinformsMap1
      Dim oSubLayers As Collection(Of String)


      If oMap.Overlays.Count = 0 Then
         oOverlay = New LayerOverlay
         oMap.Overlays.Add("WmsOverlay", oOverlay)
      Else
         oOverlay = CType(oMap.Overlays(0), LayerOverlay)
      End If

      oWMSLayer.Open()
      oWMSLayer.Name = "WMSLayer"
      oOverlay.Layers.Add(oWMSLayer.Name, oWMSLayer)
      oSubLayers = oWMSLayer.GetServerLayerNames
      For Each s As String In oSubLayers
         If Not s.ToUpper.Contains("META") And Not s.ToUpper.Contains("INDEX") Then
            oWMSLayer.ActiveLayerNames.Add(s)
         End If
      Next s

      oMap.MapUnit = GeographyUnit.DecimalDegree

      Try
         oMap.CurrentExtent = oWMSLayer.GetBoundingBox
         oWMSLayer.Close()
         oMap.Refresh()
      Catch ex As Exception
         MessageBox.Show("Error: " & ex.Message)
      End Try
   End Sub
   Private Sub SerializeWMSLayer()
      Dim oFormatter As BinaryFormatter
      Dim oStream As FileStream
      Dim sFileName As String
      Dim oOverlay As LayerOverlay

      sFileName = GetUserFolder() & "WMSLayer.wxd"

      '***** Open a file stream to use for serialization
      oFormatter = New BinaryFormatter()
      oStream = New FileStream(sFileName, FileMode.Create, FileAccess.Write, FileShare.None)


      oOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      'oLayer = oOverlay.Layers("WMSLayer")
      'If oLayer.IsOpen Then
      '   oLayer.Close()
      'End If
      If oOverlay.Layers(0).IsOpen Then
         oOverlay.Layers(0).Close()
      End If
      oFormatter.Serialize(oStream, oOverlay.Layers(0))

      oStream.Close()


   End Sub
   Private Sub DeSerializeWMSLayer()
      Dim oObjLayer As Object
      Dim oFormatter As BinaryFormatter
      Dim oStream As FileStream
      Dim sFileName As String = GetUserFolder() & "WMSLayer.wxd"
      Dim oLayerOverLay As LayerOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      Dim oWMSLayer As WmsRasterLayer

      '***** Open a file stream to use for deserialization
      oFormatter = New BinaryFormatter()
      oStream = New FileStream(sFilename, FileMode.Open, FileAccess.Read, FileShare.Read)

      oObjLayer = oFormatter.Deserialize(oStream)

      oWMSLayer = CType(oObjLayer, WmsRasterLayer)

      oLayerOverLay.Layers.Add(oWMSLayer.Name, oWMSLayer)

      oStream.Close()
      WinformsMap1.Refresh()

   End Sub
   Private Function GetUserFolder() As String
      Dim sBasePath As String
      Dim sApplicationPath As String

      sBasePath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)
      sApplicationPath = Application.CompanyName & "\"

      If Not Directory.Exists(sBasePath & "\" & sApplicationPath) Then
         Directory.CreateDirectory(sBasePath & "\" & sApplicationPath)
      End If

      Return sBasePath & "\" & sApplicationPath

   End Function

   Private Sub btnLoadFromServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadFromServer.Click
      AddWMSService()
   End Sub

   Private Sub btnSerialize_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
      SerializeWMSLayer()
   End Sub

   Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
      Dim oOverlay As LayerOverlay

      '***** Remove the WMS Layer from the map
      oOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      If oOverlay.Layers(0).IsOpen Then
         oOverlay.Layers(0).Close()
      End If
      oOverlay.Layers.Remove("WMSLayer")

      WinformsMap1.Refresh()
   End Sub

   Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
      DeSerializeWMSLayer()
   End Sub

   Private Sub btnBoundingBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBoundingBox.Click
      Dim oOverlay As LayerOverlay
      Dim oBoundingBox As RectangleShape

      oOverlay = CType(WinformsMap1.Overlays(0), LayerOverlay)
      If Not oOverlay.Layers(0).IsOpen Then
         oOverlay.Layers(0).Open()
      End If

      Try
         oBoundingBox = CType(oOverlay.Layers(0), WmsRasterLayer).GetBoundingBox
      Catch ex As Exception
         MessageBox.Show("Error: " & ex.Message, "Failed to get bouning box!")
      End Try

      If Not oBoundingBox Is Nothing Then
         MessageBox.Show("Successfully obtained bounding box from WMS layer")
      End If

   End Sub
End Class
